#include "BrowseView.hxx"

BrowseView::BrowseView()
{
	browseModel = Gtk::TreeStore::create (browseColumns);
	set_model (browseModel);
	append_column ("object", browseColumns.browse_text);
	set_size_request (200);
}

void BrowseView::add (Domain d)
{
	domList.push_back (d);
	rebuild();
}

void BrowseView::rebuild()
{
	browseModel->clear();
	for (list <Domain>::iterator domain = domList.begin(); domain != domList.end(); domain++)
	{
		Gtk::TreeModel::Row newDomainRow = *(browseModel->append());
		newDomainRow[browseColumns.browse_text] = (*domain).name;
		for (list <Host>::iterator host = (*domain).hostList.begin(); host != (*domain).hostList.end(); host++)
		{
			Gtk::TreeModel::Row newHostRow = *(browseModel->append (newDomainRow.children()));
			newHostRow[browseColumns.browse_text] = (*host).name;
			for (list <Iface>::iterator iface = (*host).ifaceList.begin(); iface != (*host).ifaceList.end(); iface++)
			{
				Gtk::TreeModel::Row newIfaceRow = *(browseModel->append (newHostRow.children()));
				newIfaceRow[browseColumns.browse_text] = (*iface).getName();
			}
		}
	}
	columns_autosize();
}

void BrowseView::clear()
{
	domList.clear();
	rebuild();
}

string BrowseView::getSelectedIfaceName()
{
	Glib::RefPtr<Gtk::TreeSelection> selection = get_selection();
	Gtk::TreeIter i = selection->get_selected();
	if (i)
	{
		Gtk::TreeModel::Row row = *i;
		return row[browseColumns.browse_text];
	}
	return "";
}

Iface BrowseView::getSelectedIface()
{
	string selName = getSelectedIfaceName();
	Iface retVal;
	if (selName != "")
		for (list <Domain>::iterator domain = domList.begin(); domain != domList.end(); domain++)
			for (list <Host>::iterator host = (*domain).hostList.begin(); host != (*domain).hostList.end(); host++)
				for (list <Iface>::iterator iface = (*host).ifaceList.begin(); iface != (*host).ifaceList.end(); iface++)
					if ((*iface).getName() == selName)
					{
						retVal = (*iface);
						break;
					}
	return retVal;
}
