#include "Domain.hxx"
#include <sys/types.h>
#include <dirent.h>
#include <sys/stat.h>
#include <unistd.h>

Domain::Domain()
{
	name = "default domain";
}

Domain::Domain (const string name)
{
	this->name = name;
}

string Domain::getName ()
{
	return name;
}

void Domain::add (const Host host)
{
	hostList.push_back (host);
}

void Domain::scan (const string dir)
{
	// TODO: scan for hosts
	Host host ("default host");
	DIR * target = opendir ((dir + "/ifaces").c_str());
	if (!target)
	{
		perror ("Domain::scan()");
		return;
	}
	struct dirent * dirEntry = NULL;
	while ((dirEntry = readdir (target)))
	{
		struct stat statbuf;
		if (lstat ((dir + "/ifaces/" + dirEntry->d_name).c_str(), &statbuf))
		{
			perror ("lstat");
			continue;
		}
		if (!S_ISDIR (statbuf.st_mode))
			continue;
		if (dirEntry->d_name[0] == '.')
			continue;
		if (string (dirEntry->d_name) == "CVS" || string (dirEntry->d_name) == "default" || string (dirEntry->d_name) == "unknown")
			continue;
		Iface iface (dir + "/ifaces", dirEntry->d_name);
		if (iface.isLoaded())
			host.add (iface);
	}
	closedir (target);
	add (host);
}
