#ifndef IFACE_H__
#define IFACE_H__
#include <string>
#include <list>
using namespace std;
#include "VarMap.hxx"
#include "QoS.hxx"

enum IfaceType
{
	IFTYPE_VIRTUAL,
	IFTYPE_REALPHYS,
	IFTYPE_HOSTEDPHYS,
	IFTYPE_INDEPLOG,
	IFTYPE_DEPLOG
};

enum IfaceBootProto
{
	IFPROTO_STATIC,
	IFPROTO_DHCP,
	IFPROTO_IPV4LL,
	IFPROTO_DHCP_STATIC,
	IFPROTO_DHCP_IPV4LL,
	IFPROTO_DHCP_IPv4LL_STATIC
};

class Iface
{
protected:
	string ifaceDir;
	string name;
	bool pickup_options();
	bool pickup_qos_tree();
	bool opt_onboot, opt_disabled;
	IfaceType opt_type;
	IfaceBootProto opt_bootproto;
	VarMap default_options, type_options, options;
	bool loaded;
	friend class IfaceView;
	QoSObject qosRoot;
public:
	Iface();
	Iface (const string ifaceDir, const string name);
	void dump();
	bool isLoaded();
	string getName();
	static string name2type (string name);
};

#endif
