#ifndef IFACEVIEW_HXX__
#define IFACEVIEW_HXX__
#include <gtkmm.h>
#include <gtkmm/layout.h>
#include <string>
using namespace std;
#include "Iface.hxx"
#include "QoS.hxx"

class VarWidget : public Gtk::HBox, public VarInstance
{
protected:
	string varName;
	bool isImported;
	void repack();
	void set (const VarInstance);
	void set (const string);
public:
	VarWidget();
	void set (const string, const VarInstance);
	VarWidget (const string, const VarInstance, const bool isImported = true);
};

class IfaceView : public Gtk::VBox
{
protected:
	Iface iface;
	void rebuild (const string s);
	Gtk::VButtonBox ifoptVBox, typeoptVBox, defoptVBox;
	Gtk::Notebook ifoptNB, typeoptNB, defoptNB;
	Gtk::HButtonBox hBox;
	Gtk::Button buttonOk, buttonCancel;
	Gtk::Frame ifoptFrame, typeoptFrame, defoptFrame, qosFrame;
	QoSView qosView;
public:
	IfaceView();
	void set (Iface i);
	void set (const string s);
};

#endif
