#ifndef QOS_HXX__
#define QOS_HXX__
#include <gtkmm.h>
using namespace std;
// 104.20 MHz FM

enum QoSType
{
	QOS_NULL,
	QOS_QDISC,
	QOS_CLASS,
	QOS_FILTER
};

class QoSObject
{
protected:
	string dev, id, parent, params, myExtra, parentExtra, nodeIdPrefix;
	QoSType type;
	bool install();
	void readParams (const string);
	void readExtra (const string);
	void readFilters (const string);
	bool test_f (const string);
public:
	list <QoSObject> children;
	QoSObject();
	const string strType();
	const string getID();
	void clear();
	void setDev (const string);
	void dump (const unsigned indent = 0);
	bool buildFromDir
	(
		const string where,
		const string id,
		const string parent,
		const string last_qdisc_handle = "",
		const string extra = ""
	);
};

class QoSColumns : public Gtk::TreeModel::ColumnRecord
{
public:
	QoSColumns()
	{
		add (id);
		add (type);
	}
	Gtk::TreeModelColumn <string> id;
	Gtk::TreeModelColumn <string> type;
};

class QoSView : public Gtk::TreeView
{
protected:
	Glib::RefPtr<Gtk::TreeStore> qosModel;
	QoSColumns qosColumns;
	QoSObject root;
	void rebuild();
public:
	void setRoot (QoSObject);
	void clear();
	QoSView();
	string getSelectedObjectID();
	QoSType getSelectedObjectType();
	QoSObject getSelectedObject();
	void processQoSObjectChildren (QoSObject, Gtk::TreeIter);
};

#endif
