#ifndef VARINFO_HXX__
#define VARINFO_HXX__
#include <string>
#include <list>
#include <map>
using namespace std;

enum VarType
{
	VT_STRING = 0,
	VT_INT,
	VT_BOOL,
	VT_ENUM
};

class VarInfo
{
protected:
	VarType varType;
	string varLabel;
	string varDescription;
	unsigned varLevel;
	list <string> enumVal;
	friend class VarInstance;
public:
	VarInfo (const VarType varType = VT_STRING, const string varLabel = "", const string varDescription = "", const unsigned varLevel = 0);
	void set (const VarType varType, const string varLabel, const string varDescription, const unsigned varLevel);
	void addEnumVal (const string val);
	VarType getType();
};

class VarInfoMap
{
protected:
	map <string, VarInfo> infoMap;
public:
	bool infoExists (const string varName);
	VarInfo getInfo (const string varName);
	void add (const string varName, const VarInfo info);
	static void loadDefaults (VarInfoMap & m);
};

#endif
