#ifndef VARLIST_HXX__
#define VARLIST_HXX__
#include "VarInfo.hxx"
#include <map>
#include <string>
using namespace std;

class VarInstance : public VarInfo
{
protected:
	string strValue; // also for enums
	bool boolValue;
	int intValue;
	friend class VarMap;
	friend class VarWidget;
	bool is_yes (const string);
public:
	const string getStrValue();
	const VarType getType();
	void setStrValue (const string value);
	VarInstance (const VarInfo & info);
	VarInstance();
};

class VarMap
{
protected:
	map <string, VarInstance> varMap;
public:
	void load (const string filename, VarInfoMap info);
	string & operator[] (const string key);
	bool exists (const string key);
	void subtract (const VarMap & v);
	void dump();
	map <string, VarInstance>::const_iterator begin();
	map <string, VarInstance>::const_iterator end();
};

#endif
